## docparser 1.0.1

=== debian/changelog ===
docparser (1.0.1-1) unstable; urgency=medium

  * update

 -- deepin <packages@deepin.com>  Thu, 23 Dec 2021 20:32:27 +0800

docparser (1.0.0) unstable; urgency=medium

  * Initial Release.

 -- unknown <liuzhangjian@uniontech.com>  Wed, 17 Nov 2021 11:31:29 +0800

## docparser 1.0.3

=== debian/changelog ===
docparser (1.0.3-1) unstable; urgency=medium

  * update

 -- deepin <packages@deepin.com>  Sat, 07 May 2022 11:02:45 +0800

## docparser 1.0.4

=== debian/changelog ===
docparser (1.0.4-1) unstable; urgency=medium

  * update

 -- deepin <packages@deepin.com>  Tue, 26 Jul 2022 09:48:36 +0800

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5
%:
	dh $@
override_dh_installinit:
	true
override_dh_auto_configure:
	dh_auto_configure -- VERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

## docparser 1.0.17

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(docparser VERSION 1.0.0 LANGUAGES CXX)

# 设置C++标准
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# 安全编译选项
add_compile_options(-fstack-protector-strong -D_FORTITY_SOURCE=1)
add_link_options(-z noexecstack -pie -fPIC)

# 设置安装路径
include(GNUInstallDirs)

# 查找依赖包
find_package(PkgConfig REQUIRED)
pkg_check_modules(DEPS REQUIRED
    poppler-cpp
    libzip
    pugixml
    freetype2
    libxml-2.0
    uuid
    tinyxml2
)

# 添加子目录
add_subdirectory(src) 

# 添加测试选项，默认不构建
option(BUILD_TESTS "Build test applications" OFF)

# 有条件地添加测试目录
if(BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS Core)
find_package(Dtk6 REQUIRED COMPONENTS Core)

# 设置测试程序的源文件
set(TEST_SOURCES
    main.cpp
)

# 创建测试可执行文件
add_executable(docparser_test ${TEST_SOURCES})

# 链接docparser库和Qt6Core
target_link_libraries(docparser_test
    PRIVATE
        docparser
        Qt6::Core
        Dtk6::Core
)

# 设置包含目录
target_include_directories(docparser_test
    PRIVATE
        ${CMAKE_SOURCE_DIR}/src
)

# 安装测试程序(可选)
install(TARGETS docparser_test
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

## docparser 1.0.10

=== debian/changelog ===
docparser (1.0.10) unstable; urgency=medium

  * update to 1.0.10

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 02 Apr 2024 10:29:06 +0800

docparser (1.0.9) unstable; urgency=medium

  * update to 1.0.9

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 27 Mar 2024 16:42:31 +0800

docparser (1.0.8) unstable; urgency=medium

  * update to 1.0.8.

 -- lvwujun <lvwujun@uniontech.com>  Mon, 04 Mar 2024 13:08:21 +0800

docparser (1.0.7) unstable; urgency=medium

  * update to 1.0.7.

 -- lvwujun <lvwujun@uniontech.com>  Tue, 05 Feb 2024 13:08:21 +0800

=== debian/control ===
Source: docparser
Section: libdevel
Priority: optional
Maintainer: deepin <packages@deepin.com>
Build-Depends:
 debhelper (>= 11),
 qtbase5-dev,
 qt5-qmake,
 pkg-config,
 libpoppler-cpp-dev,
 libzip-dev,
 libpugixml-dev,
 libfreetype6-dev|libfreetype-dev,
 libxml2-dev,
 uuid-dev,
 libtinyxml2-dev
Standards-Version: 4.3.0

Package: libdocparser
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Document parser library.
 This package contains the shared libraries.

Package: libdocparser-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdocparser
Description: Development files for libdocparser
 This package contains the header files and static libraries
 of libdocparser

## docparser 1.0.17

=== debian/changelog ===
docparser (1.0.17) unstable; urgency=medium

  * add tests
  * refactor

 -- Zhang Sheng <zhangsheng@uniontech.com>  Mon, 24 Mar 2025 17:28:27 +0800

docparser (1.0.16) unstable; urgency=medium

  * remove symbol visibility settings

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 15 Jan 2025 18:00:49 +0800

docparser (1.0.15) unstable; urgency=medium

  * use so name

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 15 Jan 2025 14:34:49 +0800

docparser (1.0.14) unstable; urgency=medium

  * fix bug
  * 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 07 Jan 2025 13:04:28 +0800

docparser (1.0.13) unstable; urgency=medium

  * Remove Qt
  * Use CMake
  * Use C++17

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 27 Dec 2024 14:06:31 +0800

docparser (1.0.12) unstable; urgency=medium

  * update to 1.0.12

 -- He Xiaodong <hexiaodong@uniontech.com>  Fri, 20 Dec 2024 17:27:53 +0800

docparser (1.0.11) unstable; urgency=medium

  * `htm` supported

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 21 May 2024 19:12:33 +0800

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,8 @@
 Priority: optional
 Maintainer: deepin <packages@deepin.com>
 Build-Depends:
+ cmake,
  debhelper (>= 11),
- qtbase5-dev,
- qt5-qmake,
  pkg-config,
  libpoppler-cpp-dev,
  libzip-dev,

## docparser 1.0.21

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,9 @@
 
 # 查找依赖包
 find_package(PkgConfig REQUIRED)
-pkg_check_modules(DEPS REQUIRED
+
+# 首先尝试查找除libmagic之外的所有依赖
+pkg_check_modules(DEPS_WITHOUT_MAGIC REQUIRED
     poppler-cpp
     libzip
     pugixml
@@ -23,6 +25,39 @@
     uuid
     tinyxml2
 )
+
+# 单独处理libmagic依赖，兼容新旧环境
+set(LIBMAGIC_FOUND FALSE)
+set(LIBMAGIC_LIBRARIES "")
+set(LIBMAGIC_INCLUDE_DIRS "")
+
+# 首先尝试使用pkg-config查找libmagic（新环境）
+pkg_check_modules(LIBMAGIC_PKG libmagic)
+if(LIBMAGIC_PKG_FOUND)
+    set(LIBMAGIC_FOUND TRUE)
+    set(LIBMAGIC_LIBRARIES ${LIBMAGIC_PKG_LIBRARIES})
+    set(LIBMAGIC_INCLUDE_DIRS ${LIBMAGIC_PKG_INCLUDE_DIRS})
+    message(STATUS "Found libmagic via pkg-config: ${LIBMAGIC_PKG_VERSION}")
+else()
+    # 回退到传统方法（旧环境）
+    find_path(LIBMAGIC_INCLUDE_DIR magic.h)
+    find_library(LIBMAGIC_LIBRARY NAMES magic)
+    
+    if(LIBMAGIC_INCLUDE_DIR AND LIBMAGIC_LIBRARY)
+        set(LIBMAGIC_FOUND TRUE)
+        set(LIBMAGIC_LIBRARIES ${LIBMAGIC_LIBRARY})
+        set(LIBMAGIC_INCLUDE_DIRS ${LIBMAGIC_INCLUDE_DIR})
+        message(STATUS "Found libmagic via traditional method: ${LIBMAGIC_LIBRARY}")
+    endif()
+endif()
+
+if(NOT LIBMAGIC_FOUND)
+    message(FATAL_ERROR "libmagic not found. Please install libmagic-dev package.")
+endif()
+
+# 合并所有依赖
+set(DEPS_LIBRARIES ${DEPS_WITHOUT_MAGIC_LIBRARIES} ${LIBMAGIC_LIBRARIES})
+set(DEPS_INCLUDE_DIRS ${DEPS_WITHOUT_MAGIC_INCLUDE_DIRS} ${LIBMAGIC_INCLUDE_DIRS})
 
 # 添加子目录
 add_subdirectory(src)

=== src/CMakeLists.txt ===
# 收集源文件
file(GLOB_RECURSE SRC_FILES_MAIN
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

file(GLOB_RECURSE SRC_FILES_3RDPARTY_LIBS
    "${CMAKE_SOURCE_DIR}/3rdparty/libs/*.cpp"
    "${CMAKE_SOURCE_DIR}/3rdparty/libs/*.hpp"
    "${CMAKE_SOURCE_DIR}/3rdparty/libs/*.h"

)

file(GLOB_RECURSE SRC_FILES_3RDPARTY_UTILS
    "${CMAKE_SOURCE_DIR}/3rdparty/utils/*.cpp"
    "${CMAKE_SOURCE_DIR}/3rdparty/utils/*.cc"
    "${CMAKE_SOURCE_DIR}/3rdparty/utils/*.h"
)

# 创建源文件列表
set(SRC_FILES
    ${SRC_FILES_MAIN}
    ${SRC_FILES_3RDPARTY_LIBS}
    ${SRC_FILES_3RDPARTY_UTILS}
)

# 移除重复的源文件
list(REMOVE_DUPLICATES SRC_FILES)

# 打印源文件列表，用于调试
message(STATUS "Source files:")
foreach(SOURCE_FILE ${SRC_FILES})
    message(STATUS "  ${SOURCE_FILE}")
endforeach()

# 创建库目标
add_library(docparser SHARED
    ${SRC_FILES}
)

# 设置库的版本信息
set_target_properties(docparser PROPERTIES
    VERSION 1.0
    SOVERSION 1
)

# 设置目标属性
target_include_directories(docparser
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/docparser>
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_SOURCE_DIR}/3rdparty/libs
        ${CMAKE_SOURCE_DIR}/3rdparty/utils/libofd
        ${DEPS_INCLUDE_DIRS}
)

target_link_libraries(docparser
    PRIVATE
        ${DEPS_LIBRARIES}
)

# 安装目标
install(TARGETS docparser
    EXPORT docparser-targets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

# 安装头文件
install(FILES
    docparser.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/docparser
)

# 生成并安装 pkg-config 文件
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/docparser.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/docparser.pc
    @ONLY
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/docparser.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== debian/changelog ===
docparser (1.0.21) unstable; urgency=medium

  * enhance CMake configuration for libmagic dependency handling

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 26 Jun 2025 12:49:21 +0800

docparser (1.0.20) unstable; urgency=medium

  *  implement truncation functionality in document parser

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 24 Jun 2025 14:14:45 +0800

docparser (1.0.19) unstable; urgency=medium

  * integrate libmagic for MIME type detection in docparser

 -- Zhang Sheng <zhangsheng@uniontech.com>  Mon, 26 May 2025 14:21:27 +0800

docparser (1.0.18) unstable; urgency=medium

  * refactor

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 22 May 2025 08:28:35 +0800

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,8 @@
  libfreetype6-dev|libfreetype-dev,
  libxml2-dev,
  uuid-dev,
- libtinyxml2-dev
+ libtinyxml2-dev,
+ libmagic-dev
 Standards-Version: 4.3.0
 
 Package: libdocparser

## docparser 1.0.22

=== CMakeLists.txt ===
--- 
+++ 
@@ -62,10 +62,12 @@
 # 添加子目录
 add_subdirectory(src) 
 
-# 添加测试选项，默认不构建
-option(BUILD_TESTS "Build test applications" OFF)
+# 添加测试选项，默认构建
+option(BUILD_TESTS "Build test applications" ON)
 
 # 有条件地添加测试目录
 if(BUILD_TESTS)
-    add_subdirectory(tests)
+    if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
+        add_subdirectory(tests)
+    endif()
 endif()

=== tests/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
find_package(Qt6 REQUIRED COMPONENTS Core Test)
find_package(Dtk6 REQUIRED COMPONENTS Core)

# Enable testing
enable_testing()

# 设置测试程序的源文件
set(TEST_SOURCES
    main.cpp
)

# 设置自动化测试的源文件
set(AUTOTEST_SOURCES
    autotest.cpp
)

# 创建测试可执行文件
add_executable(docparser_test ${TEST_SOURCES})

# 创建自动化测试可执行文件
add_executable(docparser_autotest ${AUTOTEST_SOURCES})

# 链接docparser库和Qt6Core
target_link_libraries(docparser_test
    PRIVATE
        docparser
        Qt6::Core
        Dtk6::Core
)

# 链接自动化测试所需的库
target_link_libraries(docparser_autotest
    PRIVATE
        docparser
        Qt6::Core
        Qt6::Test
)

# 设置包含目录
target_include_directories(docparser_test
    PRIVATE
        ${CMAKE_SOURCE_DIR}/src
)

target_include_directories(docparser_autotest
    PRIVATE
        ${CMAKE_SOURCE_DIR}/src
)

# 添加测试到CTest
add_test(
    NAME DocParserAutoTest
    COMMAND docparser_autotest
)

# 设置测试属性
set_tests_properties(DocParserAutoTest PROPERTIES
    TIMEOUT 300  # 5 minutes timeout for all tests
)

# 安装测试程序(可选)
install(TARGETS docparser_test docparser_autotest
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
docparser (1.0.22) unstable; urgency=medium

  * enhance error handling in formula evaluation

 -- liujinchang <liujinchang@uniontech.com>  Tue, 05 Aug 2025 19:35:19 +0800
